#pragma once
#include <fstream>
#include <vector>
#include <set>
#include <unordered_set>

#include "HelperTypes.h"


class MeshLoader
{
protected:
    std::vector<Node> nodes;
    std::vector<FiniteElement> elements;
    std::vector<BoundaryFiniteElement> boundary;

public:

    virtual void LoadMesh(const std::string&) = 0;
    virtual ~MeshLoader() = default;

    void PrintData();
  
    std::vector<Node>& GetNodes()
    {
        return nodes;
    }
    std::vector<FiniteElement>& GetElements()
    {
        return elements;
    }
    std::vector<BoundaryFiniteElement>& GetSurfaces()
    {
        return boundary;
    }
 
    std::vector<FiniteElement> GetElementsID(int id1, int id2, int id3);
    std::vector<FiniteElement> GetElementsrib(int id1, int id2);
    std::vector<FiniteElement> GetElementsIDarea(int a_id);
    std::vector<Node> GetVertexNodesBorderID(int s_id);
    std::vector<BoundaryFiniteElement> GetBordersBorderID(int s_id);
    void InsertNewNodes();
    std::vector<std::set<int>> GetNodesNeighbors();
    Node GetNodeID(int n_id);

};
